# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 2.4.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class EarthCenteredFrameId(str, Enum):
    """
    Frame of reference that can be inertial or not<br> - ```CIRF```: Celestial Intermediate Reference Frame. this is a quasi-inertial Earth-centred system. - ```EME2000```: Earth Mean Equator and Equinox at epoch J2000. The J2000 frame is realized by the transformational algorithm between it and the Earth Fixed frame. - ```GCRF```: Geocentric Celestial Reference Frame. It is a standard inertial coordinate system for the Earth, with origin at the geocenter. - ```GTOD```: Greenwich True-of-Date. It is a rotating, right-handed, Cartesian system with the origin at the Earth's center. - ```ITRF2020```: International Terrestrial Reference Frame. It is a rotating Earth-Fixed frame with data from 2020 used in the frame formation. - ```TOD```: True-of-Date. It is a quasi-inertial frame definition for central bodies. 
    """

    """
    allowed enum values
    """
    CIRF = 'CIRF'
    EME2000 = 'EME2000'
    GCRF = 'GCRF'
    GTOD = 'GTOD'
    ITRF2020 = 'ITRF2020'
    TOD = 'TOD'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of EarthCenteredFrameId from a JSON string"""
        return cls(json.loads(json_str))


