# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 2.4.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from spacetower_orbit_extrapolation_python_client.models.event_detection_type import EventDetectionType
from spacetower_orbit_extrapolation_python_client.models.field_of_view import FieldOfView
from spacetower_orbit_extrapolation_python_client.models.target_celestial_body import TargetCelestialBody
from spacetower_orbit_extrapolation_python_client.models.time_span import TimeSpan
from typing import Optional, Set
from typing_extensions import Self

class FieldOfViewEventRequest(BaseModel):
    """
    Log acquisitions inside the Field of View (FoV) on an on-board sensor. The target is a celestial body e.g. the Sun and is considered as acquired as soon as part of it is in the FoV (Earth occultation status is given in event log)
    """ # noqa: E501
    event_detection_type: Optional[EventDetectionType] = Field(default=None, alias="eventDetectionType")
    time_span: Optional[TimeSpan] = Field(default=None, alias="timeSpan")
    minimum_duration: Optional[Union[Annotated[float, Field(strict=True, ge=10.0)], Annotated[int, Field(strict=True, ge=10)]]] = Field(default=60.0, description="Minimum duration of acquisition to consider (a value unrealistically small would lower computational performance). Units [s]", alias="minimumDuration")
    field_of_view: FieldOfView = Field(alias="fieldOfView")
    target_body_names: Annotated[List[TargetCelestialBody], Field(min_length=1)] = Field(description="The list of celestial bodies to be acquired in the Field of View", alias="targetBodyNames")
    __properties: ClassVar[List[str]] = ["eventDetectionType", "timeSpan", "minimumDuration", "fieldOfView", "targetBodyNames"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FieldOfViewEventRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of time_span
        if self.time_span:
            _dict['timeSpan'] = self.time_span.to_dict()
        # override the default output from pydantic by calling `to_dict()` of field_of_view
        if self.field_of_view:
            _dict['fieldOfView'] = self.field_of_view.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FieldOfViewEventRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "eventDetectionType": obj.get("eventDetectionType"),
            "timeSpan": TimeSpan.from_dict(obj["timeSpan"]) if obj.get("timeSpan") is not None else None,
            "minimumDuration": obj.get("minimumDuration") if obj.get("minimumDuration") is not None else 60.0,
            "fieldOfView": FieldOfView.from_dict(obj["fieldOfView"]) if obj.get("fieldOfView") is not None else None,
            "targetBodyNames": obj.get("targetBodyNames")
        })
        return _obj


