# coding: utf-8

"""
    Orbit Extrapolation API

    Orbit Extrapolation API

    The version of the OpenAPI document: 2.4.2
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from spacetower_orbit_extrapolation_python_client.models.rotating_local_frame_id import RotatingLocalFrameId
from spacetower_orbit_extrapolation_python_client.models.secondary_object_event_types import SecondaryObjectEventTypes
from spacetower_orbit_extrapolation_python_client.models.vector3_d import Vector3D
from typing import Optional, Set
from typing_extensions import Self

class SecondaryObjectEventLog(BaseModel):
    """
    Secondary event summary 
    """ # noqa: E501
    utc_date: str = Field(description="The event's UTC date", alias="utcDate")
    event_type: SecondaryObjectEventTypes = Field(alias="eventType")
    secondary_name: StrictStr = Field(description="Name of the secondary object", alias="secondaryName")
    relative_distance: Union[StrictFloat, StrictInt] = Field(description="The norm of the relative position vector", alias="relativeDistance")
    relative_position_vector: Vector3D = Field(alias="relativePositionVector")
    relative_velocity_vector: Vector3D = Field(alias="relativeVelocityVector")
    local_frame_id: RotatingLocalFrameId = Field(alias="localFrameId")
    __properties: ClassVar[List[str]] = ["utcDate", "eventType", "secondaryName", "relativeDistance", "relativePositionVector", "relativeVelocityVector", "localFrameId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SecondaryObjectEventLog from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of relative_position_vector
        if self.relative_position_vector:
            _dict['relativePositionVector'] = self.relative_position_vector.to_dict()
        # override the default output from pydantic by calling `to_dict()` of relative_velocity_vector
        if self.relative_velocity_vector:
            _dict['relativeVelocityVector'] = self.relative_velocity_vector.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SecondaryObjectEventLog from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "utcDate": obj.get("utcDate"),
            "eventType": obj.get("eventType"),
            "secondaryName": obj.get("secondaryName"),
            "relativeDistance": obj.get("relativeDistance"),
            "relativePositionVector": Vector3D.from_dict(obj["relativePositionVector"]) if obj.get("relativePositionVector") is not None else None,
            "relativeVelocityVector": Vector3D.from_dict(obj["relativeVelocityVector"]) if obj.get("relativeVelocityVector") is not None else None,
            "localFrameId": obj.get("localFrameId")
        })
        return _obj


